<cfsetting enablecfoutputonly="true" />

<cfset request.startTime = getTickCount() />
<cfset APP_LOADED_KEY = "appVarsLoadedAt" />
<cfset THIS_DIR = getDirectoryFromPath(getCurrentTemplatePath()) />

<cfif NOT isDefined("attributes") OR NOT isStruct(attributes)>
	<cfset attributes = structNew() />
</cfif>
<cfset structAppend(attributes, url, true) />
<cfset structAppend(attributes, form, true) />

<cfapplication name="rhino_app" />

<cfif structKeyExists(attributes, "reload") OR structKeyExists(attributes, "init")>
	<cfset structDelete(application, APP_LOADED_KEY) />
<cfelseif structKeyExists(application, APP_LOADED_KEY)>
	<cfdirectory action="list"
		directory="#THIS_DIR#/rhino"
		filter="rhino.cfc"
		name="get" />
	<cfquery dbtype="query" name="get">
		select max(dateLastModified) as dlm
		from [get]
	</cfquery>
	<cfif get.dlm GTE application[APP_LOADED_KEY]>
		<cfset structDelete(application, APP_LOADED_KEY) />
	</cfif>
</cfif>

<cfif NOT structKeyExists(application, APP_LOADED_KEY)>
<cflock scope="application" type="exclusive" timeout="30">
<cfif NOT structKeyExists(application, APP_LOADED_KEY)>
	<cfset timestamp = now() />
	
	<cfset application.rhino = createObject("component", "rhino.rhino").init(
		getDirectoryFromPath(getCurrentTemplatePath()) & "scripts/"
	) />
	
	<!--- record that we've successfully loaded --->
	<cfset application[APP_LOADED_KEY] = timestamp />
</cfif>
</cflock>
</cfif>