<cfcomponent output="false">
	<!---
	This CFC is required because invocations of CF callbacks happen
	within the context of the method that actually launches
	Rhino.  To avoid variables collisions and thread safety issues, we
	do that here, instead of in rhino.cfc directly.
	--->

	<cffunction name="init" access="package" output="false" returntype="rhinorequest">
		<cfargument name="script" required="true" />
		<cfset variables.my.__rhino_script__ = script />
		<cfreturn this />
	</cffunction>
	
	
	
	<cffunction name="execute" access="package" output="false" returntype="void">
		<cfargument name="__rhino_context__" required="true" />
		<cfargument name="__rhino_scope__" required="true" />
		<cfset my.__rhino_script__.exec(__rhino_context__, __rhino_scope__) />
	</cffunction>
	
	
	
	<cffunction name="getLocalPageContext" access="public" output="false" returntype="any">
		<cfreturn getPageContext() />
	</cffunction>

<cfoutput></cfoutput>
</cfcomponent>