<cfinclude template="_setup.cfm" />

<cfset attrs = getAttributes("cfquery") />

<cfset sql = extractAttribute(attrs, "sql") />
<cfset name = extractAttribute(attrs, "name") />
<cfset params = extractAttribute(attrs, "params") />
<cfset attrs["name"] = "get" />

<cfset singleQuotedStrings = structNew() />
<cfset doubleQuotedStrings = structNew() />

<cfset sql = removeQuotedStrings(sql, singleQuotedStrings, "'") />
<cfset sql = removeQuotedStrings(sql, doubleQuotedStrings, """") />

<cfset parts = listToArray(sql, ":") />

<cfloop from="#arrayLen(parts)#" to="2" index="i" step="-1">
	<cfset index = REFind("[^a-zA-Z0-9_]", parts[i]) />
	<cfif index GT 0>
		<cfset name = left(parts[i], index - 1) />
		<cfset parts[i] = removeChars(parts[i], 1, len(name)) />
		<cfset arrayInsertAt(parts, i, name) />
	</cfif>
</cfloop>

<cfquery attributeCollection="#attrs#">
	<cfloop from="1" to="#arrayLen(parts)#" index="i">
		<cfif i MOD 2 EQ 0>
			<cfif params[parts[i]]['type'] EQ "null">
				<cfqueryparam null="true" />
			<cfelse>
				<cfqueryparam cfsqltype="cf_sql_#params[parts[i]]['type']#" value="#params[parts[i]]['value']#" list="#params[parts[i]]['isList']#" />
			</cfif>
		<cfelse>
			#injectQuotedStrings(injectQuotedStrings(parts[i], singleQuotedStrings, "'"), doubleQuotedStrings, """")#
		</cfif>
	</cfloop>
</cfquery>

<cfif isDefined("get")>
	<cfset setResult("cfquery", get) />
<cfelse>
	<cfset setResult("cfquery") />
</cfif>